from NumPlSolber import *   #ナンプレソルバー追加
from NumberPlaceLib import *
import random
def rand9():return int(random.random()*9+1)
def checkRand9(tb,ist,jst,R):#■3×3ブロックに値が
    for i in range(3):       #  あるかをチェック
        for j in range(3):
            if tb[i+ist][j+jst]==R:return R
    return 0
def setRand9(tb, ist, jst):#■3×3ブロックに乱数設定
    for i in range(3):
        ii=ist+i
        for j in range(3):
            R=rand9()
            while checkRand9(tb,ist,jst,R)!=0:
                R=rand9()   # 値があれば乱数を再発生
            tb[ii][jst+j]=R
def initTB():#■初期値設定
    tb=array(9,9)
    for i in range(0,9,3):setRand9(tb,i,i)
    return tb
def initTB2():#■初期値として固定値設定
    tb=[[1,0,0, 0,0,0, 4,9,2],
        [0,2,0, 0,0,0, 3,5,7],
        [0,0,3, 0,0,0, 8,1,6],
        
        [0,0,0, 4,9,2, 0,0,0],
        [0,0,0, 3,5,7, 0,0,0],
        [0,0,0, 8,1,6, 0,0,0],
 
        [4,9,2, 0,0,0, 7,0,0],
        [3,5,7, 0,0,0, 0,8,0],
        [8,1,6, 0,0,0, 0,0,9]]
    return tb
def genQ(tb,vsTB,N):#■可視箇所の設定
    Q=array(9,9);count=0;NN=N
    for i in range(len(vsTB)):# 指定可視箇所のみを設定
        for j in range(len(vsTB[i])):
            if vsTB[i][j]!=0:Q[i][j]=tb[i][j];count+=1
    if count<15:NN=15+N  # 可視箇所が少なければ
    for i in range(NN):  # 乱数設定を増やす
        ix=rand9()-1;iy=rand9()-1
        while Q[iy][ix]!=0:ix=rand9()-1;iy=rand9()-1
        Q[iy][ix]=tb[iy][ix]
    return Q
def makeTB(vsTB,Debug=False,setType=0):#■問題の生成
    if setType==0:tb=initTB()
    else: tb=initTB2()
    if Debug:print("■初期設定");printNP(tb)
    R=solver(tb,False)# 1個の解を求める
    if Debug:
        print("■解",R);printNP(tb)
        print("解の数",R[1])
    numAns=0;N=0
    while numAns!=1:#解の数が1になるまで処理
        Q=genQ(tb,vsTB,N) # 可視箇所設定
        if Debug:print("■問題候補");printNP(Q)
        R=solver(Q,True)  # 問題を解いて
        numAns=R[1]       # 解の数設定
        if Debug:print("解の数",numAns)
        N+=1
    if Debug: print("解答");printNP(tb)
    return Q
vsTB=[[[1,0,0, 0,1,0, 0,0,1],
       [0,1,0, 0,1,0, 0,1,0],
       [0,0,1, 0,1,0, 1,0,0],

       [0,0,0, 0,1,0, 0,0,0],
       [1,1,1, 1,1,1, 1,1,1],
       [0,0,0, 0,1,0, 0,0,0],

       [0,0,1, 0,1,0, 1,0,0],
       [0,1,0, 0,1,0, 0,1,0],
       [1,0,0, 0,1,0, 0,0,1]],
      [[1,1,1, 0,0,0, 0,0,0],
       [0,0,0, 1,1,1, 0,0,0],
       [0,0,0, 0,0,0, 1,1,1],

       [1,0,0, 0,1,0, 0,0,0],
       [1,0,0, 1,1,1, 1,1,1],
       [1,0,0, 0,1,0, 0,0,0],

       [0,0,0, 0,0,0, 1,1,1],
       [0,0,0, 1,1,1, 0,0,0],
       [1,1,1, 0,0,0, 0,0,0]],

      [[1,0,0, 1,0,0, 1,0,0],
       [0,1,0, 0,1,0, 0,1,0],
       [0,0,1, 0,0,1, 0,0,1],
       
       [1,0,0, 1,0,1, 1,0,0],
       [0,1,0, 0,1,0, 0,1,0],
       [0,0,1, 1,0,1, 0,0,1],
       
       [1,0,0, 1,0,0, 1,0,0],
       [0,1,0, 0,1,0, 0,1,0],
       [0,0,1, 0,0,1, 0,0,1]],
      
      [[0,1,1, 1,1,1, 1,1,0],
       [1,0,0, 0,0,0, 0,0,1],
       [1,0,0, 1,1,1, 0,0,1],
       
       [1,0,1, 0,0,0, 1,0,1],
       [1,0,1, 0,1,0, 1,0,1],
       [1,0,1, 0,0,0, 1,0,1],
       
       [1,0,0, 1,1,1, 0,0,1],
       [1,0,0, 0,0,0, 0,0,1],
       [0,1,1, 1,1,1, 1,1,0]]]
def getVsTB(i):#■可視箇所の指定
    global vsTB;ii=i# 0以上のときテーブル参照
    if ii>=0:
        if ii>len(vsTB):ii=0
        return vsTB[ii]
    else:#負のとき絶対値を可視箇所の数として乱数で生成
        TB=array(9,9)
        for i in range(abs(ii)):
            ix=rand9()-1;iy=rand9()-1
            while TB[iy][ix]!=0:ix=rand9()-1;iy=rand9()-1
            TB[iy][ix]=1
        return TB
def getVsTBAll():#■全可視箇所取得
    global vsTB;return vsTB
def genSource(Q):#■問題をPythonリスト形式で表示
    N=len(Q);NN=N-1
    for i in range(N):
        if i==0:S=" "*4+"[["
        else   :S=" "*5+"["
        S+="%d"%Q[i][0]
        for j in range(1,N):
            S+=","
            if (j%3)==0:S+=" "
            S+="%d"%Q[i][j]
        if i==NN: S+="]]"
        else    : S+="],"
        print(S)
def drawVtab(canvas,VTL):
    canvas.delete("bk2")
    N=len(VTL);SZ=10;X0=20;Y0=20
    canvas.create_text(X0+200,Y0+20,text="生成ナンプレパズル",
                           font=("monospace",10),tag="bk2")        
    for k in range(N):
        canvas.create_text(X0+20,Y0-10,text="No.%d" % k,
                           font=("monospace",10),tag="bk2")        
        for i in range(9):
            Y=i*SZ+Y0
            for j in range(9):
                X=j*SZ+X0; CL="white"
                if VTL[k][i][j]!=0:CL="#0000FF"#可視部分の背景
                drawRec(canvas,X,Y,X+SZ,Y+SZ,CL,tag="bk2")
        X1=X0+9*SZ#横太線
        for i in range(4):Y=i*SZ*3+Y0;drawBnd(canvas,X0,Y,X1,Y,tag="bk2")
        Y1=Y0+9*SZ#縦太線
        for i in range(4):X=i*SZ*3+X0;drawBnd(canvas,X,Y0,X,Y1,tag="bk2")
        Y0+=110
    canvas.create_text(X0+50,Y0-10,text="乱数設定",
                       font=("monospace",8),tag="bk2")
    VRand=array(9,9)
    for i in range(9):
        Y=i*SZ+Y0
        for j in range(9):
            X=j*SZ+X0
            if random.random()>=0.33:CL="white"
            else:CL="#0000FF";VRand[i][j]=1#可視部分の背景
            drawRec(canvas,X,Y,X+SZ,Y+SZ,CL,tag="bk2")
    X1=X0+9*SZ#横太線
    for i in range(4):Y=i*SZ*3+Y0;drawBnd(canvas,X0,Y,X1,Y,tag="bk2")
    Y1=Y0+9*SZ#縦太線
    for i in range(4):X=i*SZ*3+X0;drawBnd(canvas,X,Y0,X,Y1,tag="bk2")
    return VRand
